 
// #4X 2010 Bid Ask           \/
// Knowledge of the Ancients ( )
//______________________o0o___(_)___o0o_____
//___Xard777_____________________2010_

#property indicator_chart_window

  extern color BoxColor = Black;//C'20,50,70';
  extern color TextColor = SteelBlue;

  extern string note1 = "Change font colors automatically? True = Yes";
  extern bool   Bid_Ask_Colors = True;
  extern bool   ShowBid = true;
  extern bool   ShowAsk = false;
  extern bool   show.panel = true;
  extern bool   show.info = true;
  extern int    betsize = 3000;
  extern bool   show.timer = true;
  extern color  DefaultColor = Silver;
  extern color  BidUpColor = Silver;
  extern color  BidDnColor = Silver;
  extern color  AskUpColor = Lime;
  extern color  AskDnColor = Red;
  extern string note3 = "Font Size";
  extern int    BidFontSize=48;
  extern int    AskFontSize=22;
  extern string note4 = "Font Type";
  extern string BidFontType="Arial Bold";
  extern string AskFontType="Arial";
  extern string note5 = "Display the price in what corner?";
  extern string note6 = "Upper left=0; Upper right=1";
  extern string note7 = "Lower left=2; Lower right=3";
  extern int    WhatCorner=3;
  extern string note8 = "Display the price in what window?";
  extern int    WhatWindow=0;
  extern int    WhatWindow1=1;
  extern int    WhatWindow2=2;
   
  double        Old_Ask_Price, Old_Bid_Price, DecNos, gi_88;

int init()
   {
   IndicatorShortName("  ");
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,NULL);
   return(0);
   }

int deinit()
   {
   ObjectDelete("Market_Ask_Price_Label");
   ObjectDelete("Market_Bid_Price_Label");
   
   ObjectsDeleteAll(WhatWindow,OBJ_LABEL);
   ObjectsDeleteAll(WhatWindow1,OBJ_LABEL);
   ObjectsDeleteAll(WhatWindow2,OBJ_LABEL);  
   return(0);
   }

int start()
   {
   
   if (show.timer == True)
   {
   int li_8 = Time[0] + 60 * Period() - TimeCurrent();
   double ld_0 = li_8 / 60.0;
   int li_12 = li_8 % 60;
   li_8 = (li_8 - li_8 % 60) / 60;
   
   ObjectDelete("tm");
   ObjectCreate("tm", OBJ_LABEL, WhatWindow, 0, 0);
   ObjectSetText("tm", "BarTime : " + li_8 + ":" + li_12, 15, "Arial", Silver);
   ObjectSet("tm", OBJPROP_CORNER, 1);
   ObjectSet("tm", OBJPROP_BACK, false);
   ObjectSet("tm", OBJPROP_XDISTANCE, 30);
   ObjectSet("tm", OBJPROP_YDISTANCE, 360);
   }
   
   if (StringFind (Symbol(), "JPY", 0) != -1){ DecNos = 2;}
   else { DecNos = 4; }
   
   int    counted_bars=IndicatorCounted();
   
   int AskYoffset, BidYoffset;
   color AskColor, BidColor;
   
   if (Bid_Ask_Colors == True)
      {
      if (Ask > Old_Ask_Price) AskColor = AskUpColor;
      if (Ask < Old_Ask_Price) AskColor = AskDnColor;
      if (Ask == Old_Ask_Price) AskColor = DefaultColor;
      if (Bid > Old_Bid_Price) BidColor = BidUpColor;
      if (Bid < Old_Bid_Price) BidColor = BidDnColor;
      if (Bid == Old_Bid_Price) BidColor = DefaultColor;
      Old_Ask_Price = Ask;
      Old_Bid_Price = Bid;
      }
    
   if (Bid_Ask_Colors == False)
      {
      if (Ask > Old_Ask_Price) AskColor = DefaultColor;
      if (Ask < Old_Ask_Price) AskColor = DefaultColor;
      if (Ask == Old_Ask_Price) AskColor = DefaultColor;
      if (Bid > Old_Bid_Price) BidColor = DefaultColor;
      if (Bid < Old_Bid_Price) BidColor = DefaultColor;
      if (Bid == Old_Bid_Price) BidColor = DefaultColor;
      Old_Ask_Price = Ask;
      Old_Bid_Price = Bid;
      }
    
   
   string Market_Ask_Price = DoubleToStr(Ask, DecNos);
   string Market_Bid_Price = DoubleToStr(Bid, DecNos);
   
   if(ShowBid == True && ShowAsk  == True)
      {
      if(WhatCorner == 2 || WhatCorner == 3)
         {
         AskYoffset = BidFontSize + 8;
         BidYoffset = 1;
         }
      if(WhatCorner == 0 || WhatCorner == 1)
         {
         AskYoffset = 1;
         BidYoffset = AskFontSize + 8;
         }

      ObjectCreate("Market_Ask_Price_Label", OBJ_LABEL, WhatWindow, 0, 0);
      ObjectSetText("Market_Ask_Price_Label", Market_Ask_Price, AskFontSize, AskFontType, AskColor);
      ObjectSet("Market_Ask_Price_Label", OBJPROP_CORNER, WhatCorner);
      ObjectSet("Market_Ask_Price_Label", OBJPROP_XDISTANCE, 5);
      ObjectSet("Market_Ask_Price_Label", OBJPROP_YDISTANCE, AskYoffset);
   
      
      ObjectCreate("Market_Bid_Price_Label", OBJ_LABEL, WhatWindow, 0, 0);
      ObjectSetText("Market_Bid_Price_Label", Market_Bid_Price, BidFontSize, BidFontType, BidColor);
      ObjectSet("Market_Bid_Price_Label", OBJPROP_CORNER, WhatCorner);
      ObjectSet("Market_Bid_Price_Label", OBJPROP_XDISTANCE, 10+(DecNos * 2));
      ObjectSet("Market_Bid_Price_Label", OBJPROP_YDISTANCE, 20);
       
      }
      
   if(ShowBid == True && ShowAsk == False)
      {
      BidYoffset = 1;
      
      ObjectCreate("Market_Bid_Price_Label", OBJ_LABEL, WhatWindow, 0, 0);
      ObjectSetText("Market_Bid_Price_Label", Market_Bid_Price, BidFontSize, BidFontType, BidColor);
      ObjectSet("Market_Bid_Price_Label", OBJPROP_CORNER, 3);
      ObjectSet("Market_Bid_Price_Label", OBJPROP_XDISTANCE, 30-(DecNos*5));
      ObjectSet("Market_Bid_Price_Label", OBJPROP_YDISTANCE, 25);
      }
      
   if(ShowBid == False && ShowAsk == True)
      {
      AskYoffset = 1;
      
      ObjectCreate("Market_Ask_Price_Label", OBJ_LABEL, WhatWindow, 0, 0);
      ObjectSetText("Market_Ask_Price_Label", Market_Ask_Price, AskFontSize, AskFontType, AskColor);
      ObjectSet("Market_Ask_Price_Label", OBJPROP_CORNER, WhatCorner);
      ObjectSet("Market_Ask_Price_Label", OBJPROP_XDISTANCE, 10);
      ObjectSet("Market_Ask_Price_Label", OBJPROP_YDISTANCE, AskYoffset);
      } 
      
      ObjectDelete("x2b");
      ObjectCreate("x2b", OBJ_LABEL, WhatWindow, 0, 0);
      ObjectSetText("x2b",Symbol() , 35, "Arial Bold", TextColor);
      ObjectSet("x2b", OBJPROP_CORNER, 3);
      ObjectSet("x2b", OBJPROP_BACK, false);
      ObjectSet("x2b", OBJPROP_XDISTANCE, 12);
      ObjectSet("x2b", OBJPROP_YDISTANCE, 90);


   if(show.panel == True)
      {
      ObjectCreate("Box1", OBJ_LABEL, 0, 0, 0, 0, 0);
      ObjectSetText("Box1", "g", 160, "Webdings");
      ObjectSet("Box1", OBJPROP_CORNER, 1);
      ObjectSet("Box1", OBJPROP_XDISTANCE, 1);
      ObjectSet("Box1", OBJPROP_YDISTANCE, 0);
      ObjectSet("Box1", OBJPROP_COLOR, BoxColor);
      ObjectSet("Box1", OBJPROP_BACK, false);
      
   ObjectCreate("Box2", OBJ_LABEL, 0, 0, 0, 0, 0);
      ObjectSetText("Box2", "g", 160, "Webdings");
      ObjectSet("Box2", OBJPROP_CORNER, 1);
      ObjectSet("Box2", OBJPROP_XDISTANCE, 1);
      ObjectSet("Box2", OBJPROP_YDISTANCE, 210);
      ObjectSet("Box2", OBJPROP_COLOR, BoxColor);
      ObjectSet("Box2", OBJPROP_BACK, false);   
      
   ObjectCreate("Box3", OBJ_LABEL, 0, 0, 0, 0, 0);
      ObjectSetText("Box3", "g", 160, "Webdings");
      ObjectSet("Box3", OBJPROP_CORNER, 1);
      ObjectSet("Box3", OBJPROP_XDISTANCE, 1);
      ObjectSet("Box3", OBJPROP_YDISTANCE, 420);
      ObjectSet("Box3", OBJPROP_COLOR, BoxColor);
      ObjectSet("Box3", OBJPROP_BACK, false);   
      
   ObjectCreate("Box4", OBJ_LABEL, 0, 0, 0, 0, 0);
      ObjectSetText("Box4", "g", 160, "Webdings");
      ObjectSet("Box4", OBJPROP_CORNER, 1);
      ObjectSet("Box4", OBJPROP_XDISTANCE, 1);
      ObjectSet("Box4", OBJPROP_YDISTANCE, 630);
      ObjectSet("Box4", OBJPROP_COLOR, BoxColor);
      ObjectSet("Box4", OBJPROP_BACK, false); 
      
      ObjectCreate("Box5", OBJ_LABEL, 0, 0, 0, 0, 0);
      ObjectSetText("Box5", "g", 160, "Webdings");
      ObjectSet("Box5", OBJPROP_CORNER, 1);
      ObjectSet("Box5", OBJPROP_XDISTANCE, 1);
      ObjectSet("Box5", OBJPROP_YDISTANCE, 840);
      ObjectSet("Box5", OBJPROP_COLOR, BoxColor);
      ObjectSet("Box5", OBJPROP_BACK, false);
      
      ObjectCreate("Box6", OBJ_LABEL, 1, 0, 0, 0, 0);
      ObjectSetText("Box6", "g", 160, "Webdings");
      ObjectSet("Box6", OBJPROP_CORNER, 1);
      ObjectSet("Box6", OBJPROP_XDISTANCE, 1);
      ObjectSet("Box6", OBJPROP_YDISTANCE, 0);
      ObjectSet("Box6", OBJPROP_COLOR, BoxColor);
      ObjectSet("Box6", OBJPROP_BACK, true);
      }
  
   if(show.info == True)
   {
   ObjectDelete("Obj01");
   ObjectCreate("Obj01", OBJ_LABEL, WhatWindow, 0, 0);
   ObjectSetText("Obj01", "H:"+DoubleToStr(iHigh(NULL, PERIOD_D1, 0), DecNos), 15, "Arial", TextColor);
   ObjectSet("Obj01", OBJPROP_CORNER, 3);
   ObjectSet("Obj01", OBJPROP_BACK, false);
   ObjectSet("Obj01", OBJPROP_XDISTANCE, 122);
   ObjectSet("Obj01", OBJPROP_YDISTANCE, 5);
   
   ObjectDelete("Obj02");
   ObjectCreate("Obj02", OBJ_LABEL, WhatWindow, 0, 0);
   ObjectSetText("Obj02", "L:"+DoubleToStr(iLow(NULL, PERIOD_D1, 0), DecNos), 15, "Arial", TextColor);
   ObjectSet("Obj02", OBJPROP_CORNER, 3);
   ObjectSet("Obj02", OBJPROP_BACK, false);
   ObjectSet("Obj02", OBJPROP_XDISTANCE, 10);
   ObjectSet("Obj02", OBJPROP_YDISTANCE, 5);
   
   string var1=TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS);
   
   ObjectDelete("Obj03");
   ObjectCreate("Obj03", OBJ_LABEL, WhatWindow, 0, 0);
   ObjectSetText("Obj03", var1, 15, "Arial Bold", TextColor);
   ObjectSet("Obj03", OBJPROP_CORNER, 1);
   ObjectSet("Obj03", OBJPROP_BACK, false );
   ObjectSet("Obj03", OBJPROP_XDISTANCE, 12);
   ObjectSet("Obj03", OBJPROP_YDISTANCE, 10);
   
   ObjectDelete("Obj04");
   ObjectCreate("Obj04", OBJ_LABEL, WhatWindow, 0, 0);
   ObjectSetText("Obj04", "Template by XARD777", 12, "Arial Bold", Silver);
   ObjectSet("Obj04", OBJPROP_CORNER, 1);
   ObjectSet("Obj04", OBJPROP_BACK, false);
   ObjectSet("Obj04", OBJPROP_XDISTANCE, 20);
   ObjectSet("Obj04", OBJPROP_YDISTANCE, 30);
   
   ObjectDelete("Obj05");
   ObjectCreate("Obj05", OBJ_LABEL, WhatWindow, 0, 0);
   ObjectSetText("Obj05", "Acc : "+AccountName() , 13, "Arial", TextColor);
   ObjectSet("Obj05", OBJPROP_CORNER, 1);
   ObjectSet("Obj05", OBJPROP_BACK, false);
   ObjectSet("Obj05", OBJPROP_XDISTANCE, 30);
   ObjectSet("Obj05", OBJPROP_YDISTANCE, 200);
   
   ObjectDelete("Obj06");
   ObjectCreate("Obj06", OBJ_LABEL, WhatWindow, 0, 0);
   ObjectSetText("Obj06", "Fund : "+DoubleToStr(AccountBalance(),2) , 13, "Arial", TextColor);
   ObjectSet("Obj06", OBJPROP_CORNER, 1);
   ObjectSet("Obj06", OBJPROP_BACK, false);
   ObjectSet("Obj06", OBJPROP_XDISTANCE, 30);
   ObjectSet("Obj06", OBJPROP_YDISTANCE, 220);
   
   ObjectDelete("Obj07");
   ObjectCreate("Obj07", OBJ_LABEL, WhatWindow, 0, 0);
   ObjectSetText("Obj07", "Equity : "+DoubleToStr(AccountEquity(),2) , 13, "Arial", TextColor);
   ObjectSet("Obj07", OBJPROP_CORNER, 1);
   ObjectSet("Obj07", OBJPROP_BACK, false);
   ObjectSet("Obj07", OBJPROP_XDISTANCE, 30);
   ObjectSet("Obj07", OBJPROP_YDISTANCE, 240);
   
   ObjectDelete("Obj08");
   ObjectCreate("Obj08", OBJ_LABEL, WhatWindow, 0, 0);
   ObjectSetText("Obj08", "Lot : "+DoubleToStr(AccountFreeMargin()/betsize,2) , 13, "Arial", TextColor);
   ObjectSet("Obj08", OBJPROP_CORNER, 1);
   ObjectSet("Obj08", OBJPROP_BACK, false);
   ObjectSet("Obj08", OBJPROP_XDISTANCE, 30);
   ObjectSet("Obj08", OBJPROP_YDISTANCE, 260);
   
   ObjectDelete("Obj09");
   ObjectCreate("Obj09", OBJ_LABEL, WhatWindow, 0, 0);
   ObjectSetText("Obj09", "Margin : "+DoubleToStr(AccountMargin(),2) , 13, "Arial", TextColor);
   ObjectSet("Obj09", OBJPROP_CORNER, 1);
   ObjectSet("Obj09", OBJPROP_BACK, false);
   ObjectSet("Obj09", OBJPROP_XDISTANCE, 30);
   ObjectSet("Obj09", OBJPROP_YDISTANCE, 280);
   
   ObjectDelete("Obj10");
   ObjectCreate("Obj10", OBJ_LABEL, WhatWindow, 0, 0);
   ObjectSetText("Obj10", "FreeMargin : "+DoubleToStr(AccountFreeMargin(),2) , 13, "Arial", TextColor);
   ObjectSet("Obj10", OBJPROP_CORNER, 1);
   ObjectSet("Obj10", OBJPROP_BACK, false);
   ObjectSet("Obj10", OBJPROP_XDISTANCE, 30);
   ObjectSet("Obj10", OBJPROP_YDISTANCE, 300);
   
   ObjectDelete("Obj11");
   ObjectCreate("Obj11", OBJ_LABEL, WhatWindow, 0, 0);
   ObjectSetText("Obj11", "Profit : "+DoubleToStr(AccountProfit(),2) , 13, "Arial", TextColor);
   ObjectSet("Obj11", OBJPROP_CORNER, 1);
   ObjectSet("Obj11", OBJPROP_BACK, false);
   ObjectSet("Obj11", OBJPROP_XDISTANCE, 30);
   ObjectSet("Obj11", OBJPROP_YDISTANCE, 320);
   
   double spread = MarketInfo(Symbol(), MODE_SPREAD)/10;
   
   ObjectDelete("Obj12");
   ObjectCreate("Obj12", OBJ_LABEL, WhatWindow, 0, 0);
   ObjectSetText("Obj12", "Spread : "+DoubleToStr(spread,1)+" pips", 13, "Arial", Silver);
   ObjectSet("Obj12", OBJPROP_CORNER, 1);
   ObjectSet("Obj12", OBJPROP_BACK, false);
   ObjectSet("Obj12", OBJPROP_XDISTANCE, 30);
   ObjectSet("Obj12", OBJPROP_YDISTANCE, 160);
   
   }  
 }
//----
   return(0);
  //}
//+--  